unit Smiley0;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics;

function GetScreenSaverName: PChar; export;
procedure CreateScreenSaver (MainWindow: HWnd); export;
procedure DisplayScreenSaver (MainWindow: HWnd); export;
procedure DestroyScreenSaver (MainWindow: HWnd); export;
procedure ScreenSaverOptionsDlg; export;

var
  MyTimer: Integer;

implementation

const
  AppName = 'SMILEY';
  SaverName = 'Smiley';

function GetScreenSaverName: PChar;
begin
  {This is for the Set Options dialog box title.}
  Result := SaverName;
end {GetScreenSaverName};

procedure CreateScreenSaver (MainWindow: HWnd);
begin
  {Create a timer and perform any initialization here.}
  MyTimer := SetTimer (MainWindow, 1000, 1000, Nil);
  Randomize;
end {CreateScreenSaver};

procedure DisplayScreenSaver (MainWindow: HWnd);
var
  Dc: HDc;
  Brush, BrushOld: HBrush;
  Pen, PenOld: HPen;
  CenterX, CenterY: Integer;
  Rect: TRect;
begin
  {Do your "screensaver thing" here.  Remember -
   you are using Windows API and not Delphi forms!}
  Dc := GetDC (MainWindow);
  GetWindowRect (MainWindow, Rect);
  FillRect (Dc, Rect, GetStockObject (WHITE_BRUSH));
  CenterX := Random (GetDeviceCaps (Dc, HORZRES)) - 50;
  CenterY := Random (GetDeviceCaps (Dc, VERTRES)) - 50;
  Brush := CreateSolidBrush (ColorToRGB (clYellow));
  Pen := CreatePen (PS_SOLID, 2, ColorToRGB (clBlack));
  BrushOld := SelectObject (Dc, Brush);
  PenOld := SelectObject (Dc, Pen);
  Ellipse (Dc, CenterX, CenterY, 50 + CenterX, 50 + CenterY);
  Ellipse (Dc, 15 + CenterX, 12 + CenterY, 17 + CenterX, 14 + CenterY);
  Ellipse (Dc, 30 + CenterX, 12 + CenterY, 32 + CenterX, 14 + CenterY);
  Arc (Dc, 10 + CenterX, 10 + CenterY, 40 + CenterX, 40 + CenterY,
           15 + CenterX, 25 + CenterY, 35 + CenterX, 25 + CenterY);
  SelectObject (Dc, PenOld);
  SelectObject (Dc, BrushOld);
  DeleteObject (Brush);
  DeleteObject (Pen);
  ReleaseDC (MainWindow, Dc);
end {DisplayScreenSaver};

procedure DestroyScreenSaver (MainWindow: HWnd);
begin
  {Return any windows resources you may have used here.}
  KillTimer (MainWindow, MyTimer);
end {DestroyScreenSaver};

procedure ScreenSaverOptionsDlg;
begin
  {Setup a dialog procedure here - possibly in another form/unit.}
end {ScreenSaverOptionsDlg};

end {Smiley0}.
